<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The plot is located in a Nitrate Vulnerable Zone: nitrogen can be recovered from the soil. </translate>
          </q-banner>

          <q-card-section>
            <q-select
              v-model="storeSoilNitrogenMineralization"
              :options="soilNitrogenMineralizationOptions"
              option-value="id"
              option-label="label"
              filled
              :loading="loading"
              :label="$gettext('Soil mineralization level')"
              class="q-mt-md"
            />
          </q-card-section>

          <q-card-section>
            <q-input
              v-model.number="storeGrowingSeasonDuration"
              filled
              type="number"
              :label="$gettext('Growing season duration')"
              :suffix="$gettext('days')"
              :rules="[val => val > 0 || $gettext('This field must be positive')]"
              :min="0"
              step="1"
              hide-bottom-space
              :loading="loading"
            />
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Compute</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import queryKalkulackyHnojenieSoilNitrogenMineralization from 'src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/graphql/queryKalkulackyHnojenieSoilNitrogenMineralization'

export default {
  name: 'KalkulackyHnojenieNVZPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  data () {
    return {
      kalkulackyHnojenieSoilNitrogenMineralization: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Nitrate Vulnerable Zone')
    },
    pageSubTitle () {
      return 'Kalkulacky Hnojenie'
    },
    canContinue () {
      return this.isParameterSet(this.storeSoilNitrogenMineralization) && this.isParameterSet(this.storeGrowingSeasonDuration)
    },
    loading () {
      return !this.kalkulackyHnojenieSoilNitrogenMineralization
    },
    soilNitrogenMineralizationOptions () {
      if (!this.kalkulackyHnojenieSoilNitrogenMineralization) {
        return []
      } else {
        return this.kalkulackyHnojenieSoilNitrogenMineralization.filter(miner => miner.is_active)
      }
    },
    isInNVZ () {
      return this.$store.state.fertilizationPlan.parameters.isInNVZ
    },
    storeSoilNitrogenMineralization: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilNitrogenMineralization
      },
      set (v) {
        this.updateParameter('soilNitrogenMineralization', v)
      }
    },
    storeGrowingSeasonDuration: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.growingSeasonDuration
      },
      set (v) {
        this.updateParameter('growingSeasonDuration', v)
      }
    }
  },
  async mounted () {
    if (!this.isInNVZ) {
      this.$router.replace({ name: 'kalkulackyHnojenieNutrientRequirements' })
    }

    // Load data from cache (or online if not in cache)
    await this.loadSoilNitrogenMineralization('cache-first')

    const growingSeasonDefaultDuration = this.$store.state.fertilizationPlan.parameters.cropProfile.growingSeasonDefaultDuration
    if (!this.isParameterSet(this.storeGrowingSeasonDuration) && growingSeasonDefaultDuration) {
      this.storeGrowingSeasonDuration = growingSeasonDefaultDuration
    }

    // Refresh online data (do not wait until completion)
    this.loadSoilNitrogenMineralization('network-only')
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'kalkulackyHnojenieNutrientRequirements'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'kalkulackyHnojenieSoil'
      })
    },
    async loadSoilNitrogenMineralization (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryKalkulackyHnojenieSoilNitrogenMineralization,
        fetchPolicy
      })
      this.kalkulackyHnojenieSoilNitrogenMineralization = data?.kalkulacky_hnojenie__soil_nitrogen_mineralization
    }
  }
}
</script>
